mod Ex02b

incl Mtex

incl Mtexrc

loc rem 
  \para \bf  2. CVICENIE Z PREDMETU 1-AIN-625 UVOD DO MATEMATICKEJ LOGIKY PRE 
  PROGRAMATOROV  \end 

loc rem 
  \para \bf  2. CVICENIE Z PREDMETU 1-AIN-625 UVOD DO MATEMATICKEJ LOGIKY PRE 
  PROGRAMATOROV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Datum:  \end utorok 28.9.2010 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-625-lpp/1011zs/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane primitivne 
  rekurzivnym funkciam (zakladny vyvoj, p.r. predikaty, ohranicena 
  minimalizacia). Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subor(y) \it  mtex*.cl  \end obsahuje makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuje definicie niektorych 
         funkcii a predikatov. 
   \item \para Subor(y) \it  ex*.cl  \end obsahuje ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Pocet bodov za ulohy v tomto subore: 2 
   \item \para Pocet bodov za premiove ulohy v tomto subore:: 0 
  \end
  \para Odovzdat do 4.10.2010 (pondelok) do 12:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end Downloadable lecture notes available through the 
         web page of the course. 
   \item \para \it  [2]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [3]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  [CL] Remark.  \end The module \it  Msyntax  \end in the file \it  
  msyntax.cl  \end contains the syntax of the system CL. 

rem 
  \para \bf  Chapter. Primitive Recursive Functions.  \end See [1]. 

rem 
  \para \bf  Section. Primitive Recursive Predicates and Bounded Minimalization. 
   \end 

rem 
  \para \bf  Exercise.  \end \header* fun/3 D1 'Tex_f3_rec_d1' \end Show that 
  the case discrimination function \ft D1(x,y,z) \end, where 
  \eq* 
    D1(x,y,z) = v <-> x != 0 & v = y \/ x = 0 & v = z
  \end
  \para is primitive recursive. 

fun/3 D1 'Tex_f3_rec_d1'
  D1(x,y,z) = Foo

rem 
  \para \it  [CL] Remark.  \end In the sequel do not use the non-strict version 
  of the function \ft D \end from the module \it  Standard  \end; it plays the 
  role of \it  if-then-else  \end construct. 

rem 
  \para \bf  Exercise.  \end Show that the characterstic function of the 
  equality predicate \ft x = y \end is primitive recursive. 

fun/2 Eqf 'Tex_f2_char_eqf'
  Eqf(x,y) = Foo

rem 
  \para \bf  Exercise.  \end Show that the boolean functions are primitive 
  recursive. 

fun Notf 'Tex_f1_bool_notf'
  Notf(x) = Foo

fun/2 Andf 'Tex_f2_bool_andf'
  Andf(x,y) = Foo

fun/2 Orf 'Tex_f2_bool_orf'
  Orf(x,y) = Foo

fun/2 Impf 'Tex_f2_bool_impf'
  Impf(x,y) = Foo

fun/2 Ifff 'Tex_f2_bool_ifff'
  Ifff(x,y) = Foo

rem 
  \para \bf  Exercise. \it  (1 point)  \end  \end Show that primitive recursive 
  functions are closed under the operator of bounded minimalization. 
  \para \it  Remark.  \end Prove the claim for the special case in the following 
  theory. 

theory Operator_of_bounded_minimalization

fun/2 G 'Tex_f2_g'

rem 
  \para \header* fun/2 F 'Tex_f2_f' \end Show that if \ft G(z,y) \end is a 
  binary p.r. function then so is the binary function \ft F(x,y) \end defined by 

fun/2 F 'Tex_f2_f'
  F(x,y) = \m z <= x [ G(z,y) = 1 ]

rem 
  \para \it  Proof.  \end 

fun/2 F_is_primrec 'Tex_f2_f'
  F_is_primrec(x,y) = Foo

end theory Operator_of_bounded_minimalization

rem 
  \para \bf  [CL] Remark.  \end You can test your solution by \it  interpreting 
   \end the theory. Choose \it  non-local  \end interpretation and set \it  
  component identifier suffix  \end to the string \it  _b  \end 

rem 
  \para \bf  Theorem.  \end Primitive recursive functions are closed under the 
  operator of bounded minimalization. 

rem 
  \para \bf  Bounded formulas.  \end 

rem 
  \para \bf  [CL] Syntax.  \end Examples: 
  \items 
   \item \para Atomic formulas: \ft x = y \end, \ft R(x) \end. 
   \item \para Propositional connectives: \ft \t \end, \ft \f \end, \ft ~R \end, 
         \ft R & Q \end, \ft R \/ Q \end, \ft R -> Q \end, \ft R <-> Q \end. 
   \item \para Bounded quantification: \ft \eb y y <= x: R \end, 
         \ft \ab y y <= x: R \end, \ft \eb y y < x: R \end, 
         \ft \ab y y < x: R \end. 
   \item \para Notational conventions: \ft x != y \end. 
  \end

rem 
  \para \bf  Explicit definitions of predicates with bounded formulas.  \end 

rem 
  \para \bf  [CL] Syntax.  \end \header* pred/2 Q  \end Examples: 
  \def 
    pred R 
    R(x) <-> \eb y y <= x: Q(x,y)
  \end
  \def 
    pred R 
    R(x) <-> \eb y y < x: Q(x,y)
  \end
  \def 
    pred R 
    R(x) <-> 
      \ab y y <= x: Q(x,y)
  \end
  \def 
    pred R 
    R(x) <-> 
      \ab y y < x: Q(x,y)
  \end

rem 
  \para \bf  Theorem.  \end Primitive recursive functions are closed under 
  explicit definitions of predicates with bounded formulas. 

rem 
  \para \bf  Theorem.  \end The standard comparision predicates are primitive 
  recursive. 
  \para* \it  Proof.  \end The claim follows from 
  \eq* 
    x <= y <-> \eb z z <= y: x = z
  \end
  \eq* 
    x < y <-> ~y <= x
  \end
  \eq* 
    x >= y <-> y <= x
  \end
  \eq* 
    x > y <-> y < x
  \end
  \para \it  [CL] Remark.  \end From now on you can use the builtin comparison 
  predicates. 

rem 
  \para \bf  Exercise.  \end \header* pred/2 Divides 'Tex_p2_n_divides' \end 
  Show that the predicate \ft Divides(x,y) \end holding if \ft x \end is a 
  divisor of \ft y \end is primitive recursive. 

pred/2 Divides 'Tex_p2_n_divides'
  Divides(x,y) <-> Poo

rem 
  \para \bf  Exercise. \it  (1 point)  \end  \end Show that the predicate 
  \ft Prime(x) \end holding of prime numbers is primitive recursive. 

pred Prime 
  Prime(x) <-> Poo

rem 
  \para \bf  Definitions of functions with bounded minimalization.  \end 

rem 
  \para \bf  [CL] Syntax.  \end \header* pred/2 R  \end Examples: 
  \def 
    fun F 'Tex_f1_f'
    F(x) = \m y <= x [ R(x,y) ]
  \end
  \def 
    fun F 'Tex_f1_f'
    F(x) = \m y < x [ R(x,y) ]
  \end

rem 
  \para \bf  Theorem.  \end Primitive recursive functions are closed under 
  definitions of functions with bounded minimalization. 

rem 
  \para \bf  Exercise.  \end Show that the integer division function 
  \ft x/y \end is primitive recursive. Recall that \ft x/0 = 0 \end. 

fun/2 Div 'Tex_f2_n_div'
  Div(x,y) = Foo

rem 
  \para \it  [CL] Remark.  \end From now on you can use the builtin function 
  \ft x/y \end. 

rem 
  \para \bf  Exercise.  \end Show that the remainder function \ft x mod y \end 
  is primitive recursive. Recall that \ft x mod 0 = 0 \end. 

fun/2 Mod 'Tex_f2_n_mod'
  Mod(x,y) = Foo

rem 
  \para \it  [CL] Remark.  \end From now on you can use the builtin function 
  \ft x mod y \end. 

rem 
  \para \bf  Exercise.  \end Show that the integer square root function 
  \ft Tex_f1_n_sqrt(x) \end, where 
  \eq* 
    Sq Tex_f1_n_sqrt(x) <= x & x < Sq(Tex_f1_n_sqrt(x)+1)
  \end
  \para is primitive recursive 

fun Sqrt 'Tex_f1_n_sqrt'
  Sqrt(x) = Foo

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

