mod Ex02a

incl Mtex

incl Mtexrc

incl Mauxa

loc rem 
  \para \bf  2. CVICENIE Z PREDMETU 1-AIN-625 UVOD DO MATEMATICKEJ LOGIKY PRE 
  PROGRAMATOROV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Datum:  \end utorok 28.9.2010 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-625-lpp/1011zs/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane primitivne 
  rekurzivnym funkciam (zakladny vyvoj, p.r. predikaty, ohranicena 
  minimalizacia). Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subor(y) \it  mtex*.cl  \end obsahuje makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuje definicie niektorych 
         funkcii a predikatov. 
   \item \para Subor(y) \it  ex*.cl  \end obsahuje ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Pocet bodov za ulohy v tomto subore: 1 
   \item \para Pocet bodov za premiove ulohy v tomto subore:: 0 
  \end
  \para Odovzdat do 4.10.2010 (pondelok) do 12:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end Downloadable lecture notes available through the 
         web page of the course. 
   \item \para \it  [2]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [3]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  [CL] CL-TeX.  \end 

appldisp/0 Tex_f0_g0
  Std('m',0)

rem 
  \para \bf  Chapter. Primitive Recursive Functions.  \end See [1]. 

rem 
  \para \bf  Section. Basic Development.  \end 

rem 
  \para \bf  Explicit definitions of functions.  \end 

rem 
  \para \bf  Theorem.  \end Primitive recursive functions are closed under 
  explicit definitions of functions. 

rem 
  \para \bf  Primitive recursive definitions.  \end 
  \para \it  Remark.  \end Two special cases are listed below. 

rem 
  \para \bf  Exercise.  \end Show that primitive recursive functions are closed 
  under iteration of unary functions. 
  \para \it  Remark.  \end Prove the claim in the following theory. 

theory Unary_iteration

fun F 'Tex_f1_f'

rem 
  \para \header* fun/2 If 'Tex_f2_if' \end Show that if \ft F(x) \end is a unary 
  p.r. function then so is its unary iteration \ft If(n,x) \end defined by 

fun/2 If 'Tex_f2_if'
  If(0,x) = x
  If(n+1,x) = F If(n,x)

rem 
  \para \it  Proof.  \end 

fun/2 If_is_primrec 'Tex_f2_if'
  If_is_primrec(n,x) = Foo

end theory Unary_iteration

rem 
  \para \bf  [CL] Remark.  \end You can test your solution by \it  interpreting 
   \end the theory. Choose \it  non-local  \end interpretation and set \it  
  component identifier suffix  \end to the string \it  _u  \end. 

rem 
  \para \bf  Exercise. \it  (1 point)  \end  \end Show that primitive recursive 
  functions are closed under parameterless primitive recursive definitions. 
  \para \it  Remark.  \end Prove the claim for the special case in the following 
  theory. 

theory Parameterless_primitive_recursive_definition

fun/0 G0 'Tex_f0_g0'

fun/2 H2 'Tex_f2_h'

rem 
  \para \header* fun F 'Tex_f1_f' \end Show that if \ft H2(x,z) \end is a binary 
  p.r. function then so is the unary function \ft F(x) \end defined by 

fun F 'Tex_f1_f'
  F(0) = G0
  F(x+1) = H2(x,F(x))

rem 
  \para \it  Proof.  \end 

fun F_is_primrec 'Tex_f1_f'
  F_is_primrec(x) = Foo

end theory Parameterless_primitive_recursive_definition

rem 
  \para \bf  [CL] Remark.  \end You can test your solution by \it  interpreting 
   \end the theory. Choose \it  non-local  \end interpretation and set \it  
  component identifier suffix  \end to the string \it  _p  \end. 

rem 
  \para \bf  Theorem.  \end Primitive recursive functions are closed under 
  primitive recursive definitions. 

rem 
  \para \bf  Exercise.  \end Show that the addition function \ft x+y \end is 
  primitive recursive. 

fun/2 Plus 'Tex_f2_n_plus'
  Plus(x,y) = Foo

rem 
  \para \it  [CL] Remark.  \end From now on you can use the builtin function 
  \ft x+y \end. 

rem 
  \para \bf  Exercise.  \end Show that the multiplication function \ft x*y \end 
  is primitive recursive. 

fun/2 Times 'Tex_f2_n_times'
  Times(x,y) = Foo

rem 
  \para \it  [CL] Remark.  \end From now on you can use the builtin function 
  \ft x*y \end. 

rem 
  \para \bf  Exercise.  \end Show that the exponentiation function 
  \ft Tex_f2_n_exp(x,y) \end is primitive recursive. 

fun/2 Exp 'Tex_f2_n_exp'
  Exp(x,y) = Foo

rem 
  \para \bf  Exercise.  \end Show that the summation function 
  \ft Tex_f1_n_sum(n) \end is primitive recursive. 

fun Sum 'Tex_f1_n_sum'
  Sum(n) = Foo

rem 
  \para \bf  Exercise.  \end Show that the predecessor function \ft x-1 \end is 
  primitive recursive. 

fun Pred 'Tex_f1_rec_pred'
  Pred(x) = Foo

rem 
  \para \bf  Exercise.  \end Show that the modified subtraction function 
  \ft x-y \end is primitive recursive. 

fun/2 Minus 'Tex_f2_n_minus'
  Minus(x,y) = Foo

rem 
  \para \it  [CL] Remark.  \end From now on you can use the builtin function 
  \ft x-y \end. 

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

